(define count 0)

(define zufall
  (lambda (a b)
    (+ (random (- b a -1)) a)))

(define zufallsliste
  (lambda (a b n)
    (if (= n 0)
        ()
        (cons (zufall a b) (zufallsliste a b (- n 1))))))
;------------------------------------------------------------
(define extremwert
  (lambda (ls symb)
    (cond
      [(null? (cdr ls)) (car ls)]
      [(symb (car ls) (cadr ls)) 
       (extremwert (cons (car ls) (cddr ls)) symb)]
      [else
       (extremwert (cdr ls) symb)])))

(define streichen
  (lambda (x ls)
    (cond 
      [(null? ls) ()]
      [(eq? x (car ls)) (cdr ls)]
      [else
       (cons (car ls) (streichen x (cdr ls)))])))
    
(define minsort
  (lambda (ls symb)
    (if (null? ls)
        ()
        (let ([x (extremwert ls symb)])
          (cons x (minsort (streichen x ls) symb)))))) 

(define minsort-aufwand
  (lambda (ls symb)
    (letrec
        ([extremwertsuche
          (lambda (ls)
            (cond
              [(null? (cdr ls)) (car ls)]
              [(symb (car ls) (cadr ls)) 
               (set! count (+ 1 count)) ;Extremwertsuche mit neuem Element
               (extremwertsuche (cons (car ls) (cddr ls)))]
              [else
               (set! count (+ 1 count)) ;Extremwertsuche mit altem Element
               (extremwertsuche (cdr ls))]))]
         [streiche
          (lambda (x ls)
            (cond 
              [(null? ls) ()]
              [(eq? x (car ls))
               (set! count (+ 1 count)) ;Streichen
               (cdr ls)]
              [else
               (set! count (+ 1 count)) ;Suche zum Streichen
               (cons (car ls) (streiche x (cdr ls)))]))])
      (if (null? ls)
          ()
          (let ([x (extremwertsuche ls)])
            (cons x (minsort-aufwand (streiche x ls) symb))))))) 
;------------------------------------------------------------
(define experiment
  (lambda (von bis anzahl)
    (let ([zufliste (zufallsliste von bis anzahl)])
      (set! count 0)
      (printf "Unsortierte Zufallsliste: ~n")
      (printf "~s ~n" zufliste)
      (printf "Sortierte Zufallsliste: ~n")
      (printf "~s ~n" (minsort-aufwand zufliste <))
      (printf "Anzahl der Minimumvergleiche und Streichungen: ~s ~n" count))))

(define mehrfachexperiment
  (lambda (von bis anzahl wiederholung)
    (letrec ([durchfuehren
              (lambda (whlg sum)
                (set! count 0)
                (minsort-aufwand (zufallsliste von bis anzahl) <)
                (if (= whlg 1)
                    (+ sum count)
                    (durchfuehren (- whlg 1) (+ sum count))))])
      (printf "MinSort, mittlere Anzahl der Minimumvergleiche und Streichungen: ~s ~n" 
              (/ (durchfuehren wiederholung 0) wiederholung)))))
      